<template>
  <div class="wrapper">
    <div class="container-fuild">
      <div id="headTitle">
        <Logo/>
        <h1 id="title" _msttexthash="48503" _msthash="2">
          {{ i18ntext.lngText('labo') }}
        </h1>
      </div>
    </div>
    <div class="container-fuild">
      <Header />
      <ol id="topicPath">
        <li style="margin-left: 285px">
          <router-link to="">
            <a href="dashbaord">
              <font style="vertical-align: inherit"></font>
              <font style="vertical-align: inherit">
               {{ i18ntext.lngText('labo') }}
              </font>
            </a>
          </router-link>
        </li>
      </ol>
    </div>
    <div class="p-3">
      <div class="search-box">
        <div class="search-box-title" id="Bars">
          <div id="bar">
            <router-link to="/Labolap">
              <a class="btn-radius btn btn-sm" href="#" id="bar-1"
                style="background-color: #29a5a5; border: #22adb763 1px solid;">
                <i class="fas fa-cog" style="padding-right: 5px"> </i>
                {{ i18ntext.lngText('labo') }}
              </a>
            </router-link>
            <router-link to="/viewlabolap">
              <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                <i class="fas fa-eye" style="padding-right: 5px"> </i>
                {{ i18ntext.lngText('view') }}
              </a>
            </router-link>
          </div>
          <div id="right">
            <a class="btn-radius bt-pn btn btn-sm d-flex just align-items-center" data-bs-toggle="modal"
              aria-expanded="false" data-bs-target="#alertbell"
              style="float: right; color: rgb(255, 191, 0) !important; margin-top: -2px">
              <i class="fas fa-bell" style="font-size:18px; margin-right: 5px;"></i>
              {{ labo }}
            </a>
            <a v-if="form.status === 'open' || form.status === 'inprocess'" class="btn-radius bt-pn btn btn-sm" aria-expanded="false"
              style="float: right; color: #f8f5b4; margin-top:-2px;margin-right: 11px;">
              <i class="fas fa-plus" style="padding-right: 5px"> </i>
              {{ i18ntext.lngText('menu') }}
            </a>
            <a v-else class="btn-radius bt-pn btn btn-sm" data-bs-toggle="dropdown" aria-expanded="false"
              style="float: right; color: #f8f5b4; margin-top:-2px;margin-right: 11px;">
              <i class="fas fa-plus" style="padding-right: 5px"> </i>
              {{ i18ntext.lngText('menu') }}
            </a>
            <ul class="dropdown-menu">
              <li >
                <a class="dropdown-item" data-bs-toggle="modal" data-bs-target="#staticboomId" tabindex="10028"
                  href="#"><i class="fa fa-print" aria-hidden="true"></i> {{ i18ntext.lngText('print') }} {{ i18ntext.lngText('result') }}</a>
              </li>
            </ul>
          </div>
        </div>
        <input autocomplete="off" id="search" name="search" type="hidden" value="1">
        <div class="search-box-content">
          <table width="100%" border="0" cellpadding="0" cellspacing="0" class="tbl_search">
            <tbody>
              <tr>
                <th width="10%">{{ i18ntext.lngText('patientid') }}</th>
                <td width="90%">
                  <input autocomplete="off" :disabled="true" v-model="form.pateinid" class="string_zen clear_text text" id="search_word_simei_s"
                    maxlength="50" name="patient_name" size="50" type="text" tabindex="10003">
                </td>
              </tr>
              <tr>
                <th width="10%">{{ i18ntext.lngText('patient_name') }}</th>
                <td width="90%">
                  <input autocomplete="off" v-if="form.firstname != null && form.lstname != null" :disabled="true" class="string_zen clear_text text" id="search_word_simei_s"
                    :value="form.firstname+' '+form.lstname" name="patient_name" size="50" type="text" tabindex="10003">
                    <!-- <input autocomplete="off" v-if="" :disabled="true" class="string_zen clear_text text" id="search_word_simei_s"
                    :value="form.firstname+' '+form.lstname" name="patient_name" size="50" type="text" tabindex="10003"> -->
                    <input autocomplete="off" v-else :disabled="true" class="string_zen clear_text text" id="search_word_simei_s"
                     name="patient_name" size="50" type="text" tabindex="10003">
                </td>
              </tr>
              <tr>
                <th width="10%">{{ i18ntext.lngText('age') }}</th>
                <td width="90%">
                  <input autocomplete="off" :disabled="true" v-model="form.age" class="string_zen clear_text text" id="search_word_simei_s" maxlength="50"
                    name="patient_age" size="50" type="text" tabindex="10003">
                </td>
              </tr>
              <tr>
                <th width="10%">{{ i18ntext.lngText('sex') }}</th>
                <td width="90%">
                  <input autocomplete="off" :disabled="true" v-model="form.sex" class="string_zen clear_text text" name="patient_age" size="50" type="text"
                    tabindex="10003">
                </td>
              </tr>
              <tr>
                <th width="10%">{{ i18ntext.lngText('diangosis') }}</th>
                <td width="90%">
                  <input autocomplete="off" :disabled="true" class="string_zen clear_text text" v-model="form.group_code" id="search_word_simei_s"
                    name="patient_phone" size="50" type="text" tabindex="10003">
                </td>
              </tr>
              <tr>
                <th width="10%">{{ i18ntext.lngText('phonenumber') }}</th>
                <td width="90%">
                  <input autocomplete="off" :disabled="true" class="string_zen clear_text text" v-model="form.phone1" id="search_word_simei_s"
                    name="patient_phone" size="50" type="text" tabindex="10003">
                </td>
              </tr>
            </tbody>
          </table>
          <div class="search-box-footer">
            <div v-if="form.status == 'success'" class="button type2" @click="alertMessage()" id="uniform-undefined" ><span><i class="fa fa-save" aria-hidden="true"></i>
              {{ i18ntext.lngText('submit') }}<input autocomplete="off" type="button" value="表 示" class="type2"
                   style="opacity: 0; width: 54px;"
                  tabindex="10025"></span></div>
                  <div v-else class="button type2" id="uniform-undefined" data-bs-toggle="modal" data-bs-target="#confirmsubmit"><span><i class="fa fa-save" aria-hidden="true"></i>
                    {{ i18ntext.lngText('submit') }}<input autocomplete="off" type="button" value="表 示" class="type2"
                   style="opacity: 0; width: 54px;"
                  tabindex="10025"></span></div>
            <span class="marker"></span>
          </div>
        </div>
        <div class="box-footer-pagination"></div>
      </div>
    </div>


    <div class="box">
      <div class="box-content">
        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="tbl_list">
          <thead>
            <tr>
              <th style="width: 5%"> {{ i18ntext.lngText('product_no') }}</th>
              <th style="width: 15%"> {{ i18ntext.lngText('description') }}</th>
              <th style="width: 5%"> {{ i18ntext.lngText('test_type') }}</th>
              <th style="width: 7%"> {{ i18ntext.lngText('normal_value') }}</th>
              <th style="width: 7%"> {{ i18ntext.lngText('value') }}</th>
              <th style="width: 7%">{{ i18ntext.lngText('remark') }}</th>
            </tr>
          </thead>
          <thead v-for="(item,index) in alltests">
            <tr >
              <th style="padding: 10px;">
                <input autocomplete="off" disabled class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="item.test.product_no">
              </th>
              <th style="padding: 10px;">
                <input autocomplete="off" disabled class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="item.test.description" @change="updateList(item.test)">
              </th>
              <th style="padding: 10px;">
                <input autocomplete="off" disabled class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="item.test.test_type" @change="updateList(item.test)">
              </th>
              <th style="padding: 10px;">
                <input autocomplete="off" disabled class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="item.test.normal_value">
              </th>
              <th style="padding: 10px;">
                <input autocomplete="off" v-if="form.status == 'success' || form.status === 'close'" :disabled="true" class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="item.test.test_value" >
                  <input autocomplete="off" v-else  class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="item.test.test_value" @change="updateList(item.test)">
              </th>
              <th style="padding: 10px;">
                <textarea v-if="form.status == 'success' || form.status == 'close'" :disabled="true" class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%; height: 21px;"
                  v-model="item.test.remark" @change="updateList(item.test)">
                </textarea>
                <textarea v-else class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%; height: 21px;"
                  v-model="item.test.remark" @change="updateList(item.test)">
                </textarea>
              </th>
            </tr>
            <!-- Loop subtest -->
            <tr v-for="(subtest ,number) in item.subtest" :key="number">
              <th style="padding: 10px;">
              </th>
              <th style="padding: 10px;">
                <input autocomplete="off" disabled class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="subtest.description" @change="updateList(subtest)">
              </th>
              <th style="padding: 10px;">
                <input autocomplete="off" disabled class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="subtest.test_type" @change="updateList(subtest)">
              </th>
              <th style="padding: 10px;">
                <input autocomplete="off" disabled class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="subtest.normal_value">
              </th>
              <th style="padding: 10px;">
                <input autocomplete="off" v-if="form.status == 'success' || form.status === 'close'" :disabled="true" class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="subtest.test_value" >
                  <input autocomplete="off" v-else  class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%;"
                  v-model="subtest.test_value" @change="updateList(subtest)">
              </th>
              <th style="padding: 10px;">
                <textarea v-if="form.status == 'success' || form.status == 'close'" :disabled="true" class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%; height: 21px;"
                  v-model="subtest.remark" @change="updateList(subtest)">
                </textarea>
                <textarea v-else class="clear_text code text" id="jusinsya_code" type="text" style="width: 100%; height: 21px;"
                  v-model="subtest.remark" @change="updateList(subtest)">
                </textarea>
              </th>
            </tr>

            <!-- end loop -->
          </thead>
          <vue-countdown style="display: none" v-if="counting" :time="60000" @end="onCountdownEnd"
            v-slot="{ totalSeconds }">Fetch again {{ totalSeconds }} seconds later</vue-countdown>
        </table>
      </div>
    </div>


    <!-- view modal  -->
   

    <div class="modal fade ui-modal" id="alertbell" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
      aria-labelledby="staticboomId" aria-hidden="true">
      <div class="modal-dialog " id="recept">
        <div class="modal-content ui-dialog">
          <div class="ui-widget-header">
            <h5 class="modal-title in-header" id="staticBackdropLabel"><i class="fa fa-print" aria-hidden="true"></i>
              {{ i18ntext.lngText('view') }}</h5>
            <span class="ui-icon ui-icon-closethick" data-bs-dismiss="modal" aria-label="Close"></span>
          </div>
          <div class="ui-dialog-content ">
            <div class="card">
              <div class="card-body">
                <div class="mt-3">
                  <div>
                    <div class=" my-2  justify-content-center">
                      <table class="table table-striped br-table">
                        <thead>
                          <tr class="header-table">
                            <th>{{ i18ntext.lngText('no') }}</th>
                            <th class="text-center" style="text-align: center !important; width:10%;">{{ i18ntext.lngText('visitdate') }}</th>
                            <th class="text-center" style="text-align: center !important; width:10%">{{ i18ntext.lngText('patientid') }}</th>
                            <th class="text-center" style="text-align: center !important; width: 10%;">{{ i18ntext.lngText('patient_name') }}</th>
                            <th class="text-center" style="text-align: center !important;">{{ i18ntext.lngText('sex') }}</th>
                            <th class="text-center">{{ i18ntext.lngText('age') }}</th>
                            <th class="text-center" style="text-align: center !important;">{{ i18ntext.lngText('phonenumber') }}</th>
                            <th class="text-center">{{ i18ntext.lngText('diangosis') }}</th>
                            <th class="text-center">{{ i18ntext.lngText('allergies') }}</th>
                            <th></th>
                          </tr>
                        </thead>
                        <tbody>
                          <tr v-for="(item,index) in allItem" :key="index">
                            <td>{{ index + 1 }}</td>
                            <td>{{ formatdatetime(item.Date) }}</td>
                            <td>{{ item.pateinid }}</td>
                            <td>{{ item.firstname }} {{ item.lstname }}</td>
                            <td>{{ item.sex }}</td>
                            <td>{{ item.age }} </td>
                            <td>{{ item.phone1 }}</td>
                            <td>{{ item.diagnosis }}</td>
                            <td>{{ item.allergies }}</td>
                            <td class="text-center">
                              <div class="button" id="uniform-undefined" @click="select(item.labId)"
                                data-bs-toggle="modal">
                                <span><i class="fa fa-edit"></i> {{ i18ntext.lngText('detail') }}<input autocomplete="off" type="button" tabindex="10028"
                                    style="opacity: 0; width: 70px" /></span>
                              </div>
                            </td>
                          </tr>
                        </tbody>
                      </table>
                    </div>
                    <hr>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <div class="button type2" id="uniform-undefined">
              <span>{{ i18ntext.lngText('close') }}</span>
              <input autocomplete="off" type="button" value="clear" class="type2" data-bs-dismiss="modal" aria-label="Close"
                @click="clear()" style="opacity: 0; width: 63px" tabindex="10026" />
            </div>

          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- print -->
  <div class="modal fade ui-modal" id="staticboomId" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
        aria-labelledby="payment" aria-hidden="true">
        <div class="modal-dialog " style="max-width: 160vh !important;">
            <div class="modal-content ui-dialog" style="overflow-y: scroll !important; height: 92vh;">
                <div class="ui-widget-header">
                    <p>{{ i18ntext.lngText('result') }}</p>
                    <span class="ui-icon ui-icon-closethick" data-bs-dismiss="modal" aria-label="Close"></span>
                </div>
                <div class="ui-dialog-content font-khmer " id="purchaseorder">
                    <header class="Hcard" style="padding-left: 5rem; padding-right: 5rem;">
                        <div id="hcard">
                            <div class="Hcard-1" style="display: grid; position:absolute; left:0">
                              <img  src="img/logolab1.png" alt="Logo" style="width:125px"/>
                            </div>
                            <div class="Hcard-1">
                                <h1 class="text-center">
                                  Kampot-Lab
                                </h1>
                                <div class="Hcard-2" style="width: 315px;">
                                    <p class="d-flex justify-content-center text-center" style="font-size: 21px; color:black">
                                        {{company.company_Address}} <br>
                                        {{company.company_Email}} <br>
                                        {{company.company_Phone}}
                                    </p>
                                </div>
                            </div>
                            <div class="Hcard-1"></div>
                        </div>
                      </header>


                    <div class=" font-18">

                        <div class="cdata" style="padding-top: 0;​ margin-bottom: 2rem;">
                          <div class="result-information">
                            <div>
                              <table>
                              <tr>
                                <th style="width:6rem">លេខកូដ</th>
                                <td>: {{ form.preid }}</td>
                              </tr>
                              <tr>
                                <th>ឈ្មោះអ្នកជម្ងឺ</th>
                                <td>: <span class="patient-name">{{ form.firstname }} {{form.lstname}}</span></td>
                              </tr>
                              <tr>
                                <th>លេខទូរស័ព្ទ</th>
                                <td>: {{ form.phone1 }}</td>
                              </tr>
                              <tr>
                                <th>សំពាធឈាម</th>
                                <td>: {{ form.bp }}mmHg</td>
                              </tr>
                              <tr>
                                <th>សំពាំធអុកសុីសែន</th>
                                <td>: {{ form.spo2 }}/mn</td>
                              </tr>
                            </table>
                            </div>
                          
                            <div>
                              <table>
                              <tr>
                                <th style="width:8rem">លេខសម្គាល់អ្នកជម្ងឺ</th>
                                <td>: {{ form.pateinid }}</td>
                              </tr>
                              <tr>
                                <th>អាយុ</th>
                                <td>: {{ form.age }} ឆ្នាំ</td>
                              </tr>
                              <tr>
                                <th>ភេទ</th>
                                <td>: {{ form.sex }}</td>
                              </tr>
                              <tr>
                                <th>កម្ពស់</th>
                                <td>: {{ form.height }}m</td>
                              </tr>
                              <tr>
                                <th>ជីពចរ</th>
                                <td>: {{ form.pr }}</td>
                              </tr>
                           
                            </table>
                            </div>
                            <div>
                              <table>
                              <tr>
                                <th>កាលបរិច្ឆេទពិនិត្យ</th>
                                <td>: {{ formatdatetime(form.visit_date) }}</td>
                              </tr>
                              <tr>
                                <th>ថ្ងៃខែឆ្នាំកំណើត</th>
                                <td>: {{ formatdatetime(form.birstdate) }}</td>
                              </tr>
                              <tr>
                                <th>ទម្ងន់</th>
                                <td>: {{ form.width }} Kg</td>
                              </tr>
                              <tr>
                                <th>កម្តៅ</th>
                                <td>: {{ form.t }} °C</td>
                              </tr>
                              
                            </table>
                            </div>
                            
                          </div>
                          <table>
                            <tr>
                                <th>ប្រតិកម្ម</th>
                                <td>: {{ form.allergies }}</td>
                              </tr>
                            <tr>
                                <th>អាការ</th>
                                <td>: {{ form.group_code  }}</td>
                              </tr>
                              
                              <tr>
                                <th>ប្រវត្តិជម្ងឺ</th>
                                <td>: {{ form.history_disease }}</td>
                              </tr>
                              <tr>
                                <th style="width:6rem">កំណត់ចំណាំ</th>
                                <td>: {{ form.remark }}</td>
                              </tr>
                             
                            </table>
                            <div style="height:0.2px ; width:100%;margin-bottom: 0.5rem;margin-top:0.5rem;"></div>

                        </div>
                        <div class="result-container center-contain" style="padding-bottom: 5rem !important;">
                          <div class="background-img">
                            <img src="img/logolab1.png" />
                          </div>
                          <table id="hd">
                            <thead>
                              <tr style="height: 20px;" class="result-thead">
                                        <th style="width:40%">{{i18ntext.lngText('test_name')}}</th>
                                        <th style="width:15%">{{ i18ntext.lngText('result') }}</th>
                                        <th style="width:27%;padding-left:20px">{{ i18ntext.lngText('ref_value') }}</th>
                                        <th style="width:15%">{{ i18ntext.lngText('unit') }}</th>
                            </tr>
                            </thead>
                            <tbody v-for="element in result_test">
                                <tr>
                                  <th colspan="4" class="result-title">{{ element.name }}</th>
                                </tr>
                                <tr class="result-row" v-for="item in element.items" style="height: 30px;">

                                  <td>{{ item.description }}</td>
                                  <td v-if="checkValue(item.normal_value)" v-html="formatresult(item.test_value,item.normal_value)" colspan="2"></td>
                                  <td v-else v-html="formatresult(item.test_value,item.normal_value)" ></td>
                                  <td v-if="!checkValue(item.normal_value)" v-html="formatvalue(item.normal_value)" style="padding-left:20px"></td>
                                  <td>{{ item.stock_unit_of_measure_code }}</td>
                                </tr>
                            </tbody>  
                          </table>
                  </div>
                </div>
                <footer class="footer">
                    <div class="doctor-grid">
                      <div class="doctor-grid-01">
                        <p class="doctor-name">Lab Technician</p>
                        <p class="doctor-ref">(Ref. By: <span style="font-weight: bold;">{{ doctor }}</span>)</p>
                      </div>
                    
                    </div>
                    <div>
                      <p class="Generateon">Generated on : {{ time }}</p>
                    </div>
                </footer>
                 
                </div>
                <div class="modal-footer">
                    <a v-print="'#purchaseorder'" class="btn-purchase btn-light text-capitalize border-0"
                        data-mdb-ripple-color="dark"><i class="fas fa-print text-primary"></i> {{ i18ntext.lngText('print') }}</a>
                </div>
            </div>
        </div>
    </div>
  <div id="myModal" class="lskymodal">
    <div class="lskymodal-content">
      <p><i class="fa fa-check" aria-hidden="true"></i> {{ message }}</p>
    </div>
  </div>

  <div class="modal fade ui-modal" id="confirmsubmit" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
        aria-labelledby="clearconfirmlabel" aria-hidden="true">
        <div class="modal-dialog smallpopup" id="nonbackgroundboom">
            <div class="modal-content ui-dialog">
                <div class="ui-widget-header">
                    <h5 class="modal-title" id="exampleModalLabel">
                        <span class="ui-dialog-title" id="ui-dialog-title-modal-edit-dialog">{{ i18ntext.lngText('confirm_message') }}</span>
                    </h5>
                    <span class="ui-icon ui-icon-closethick btn-cancel" data-bs-dismiss="modal"
                        aria-label="Close"></span>
                </div>
                <div class="ui-dialog-content" style="background-color: #fff;">
                    <div class="modal-body">{{ i18ntext.lngText('submitback_message') }}</div>
                    <div class="modal-footer">

                        <div class="button type2" id="uniform-undefined" data-bs-dismiss="modal">
                            <span>{{ i18ntext.lngText('No') }}<input autocomplete="off" type="button" class="type2" tabindex="10008" value="No"
                                    style="width: 89px; opacity: 0;">
                            </span>

                        </div>
                        <div class="button type2" data-bs-dismiss="modal" @click="submitBack()"><span>{{ i18ntext.lngText('yes') }}</span></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

  <Footer />
  <UserInfo/>
</template>

<script>
import Auth from '../../auth/Auth';
  import print from 'vue3-print-nb';
  import Header from '../Header.vue'
  import moment from "moment";
  import Footer from "../footer.vue";
  import axios from "axios";
  import Logo from "../logo.vue"
  import i18n from "../../i18n/i18n";
  import UserInfo from "../UserInfo.vue";
  export default {
    name: "Laboratory",
    components: { Header, Footer,Logo,UserInfo },
    directives: {
      print
    },
    data() {
      return {
        i18ntext: i18n,

        form: {
          sex: 'Both'
        },
        labo:0,
        allItem: [],
        pre: '',
        form: {
          pateinid: '',
          firstname: '',
          lstname: '',
          allergies: '',
          sex: '',
          age: '',
          history_disease: '',
          address: '',
          address2: '',
          village: '',
          commune: '',
          district: '',
          phone1: '',
          pro_city: '',
          id: '',
          Date: '',
          group_code: '',
          labId: '',
          BP: '',
          pr: '',
          rr: '',
          Spo2: '',
          T: '',
          remark: '',
          status: '',
          created_by: '',
          updated_by: ''

        },
        company: [],
        alltests: [],
        message: '',
        result_test: [],
        count:0,

        time : '',
        doctor : '',

      }
    },
    async mounted() {
        if (Auth.check()) {
      if (!Auth.checkPermission("LABO_ALL")) {
        this.$router.push("/dashboard");
      }
    }
      try {
        if (this.$route.query.id != "undefined") {
          this.pre = this.$route.query.id;
        }
      } catch (error) {
        console.log(error)
      }
      this.getTest()

      this.checkedActive()
      this.getPatienLabo()
      this.selectData()
      this.getcompany()
      this.getResultlabo()

      var date = new Date()
      this.time = moment(date).format('DD-MM-YYYY hh:mm')

    },
    methods: {
      async getDoctorname(){
        await axios.post('api/v1/labo/getDoctorName',this.form)
                    .then(res => {
                      this.doctor = res.data.doctor
                    })
      },
    async  getcompany() {
               await axios.get("/api/v1/getSetup/")
                    .then((response) => {
                        this.company = response.data;
                        this.dateformart = moment(new Date()).format('DD-MM-YYYY');
                    });
            },
            async getResultlabo(){
                if(this.pre != 'undefined')
                {
                    await axios.get('api/v1/getresultLabo/'+this.pre)
                                .then(res => {
                                    this.result_test = this.groupBy(res.data)
                                })
                }
            },
            groupBy(arr) {
                const output = arr.reduce((acc, curr) => {
                    const matchItem = acc.find(item => item.name === curr.group_code);
                    if (matchItem) {
                        matchItem.items.push(curr);
                    } else {
                        acc.push({
                            name: curr.group_code,
                            items: [curr]
                        })
                    }
                    return acc;
                }, []);
                return output;
            },
      checkedActive() {
        var items = document.querySelectorAll(".radio > span")
        for (let i = 0; i < items.length; i++) {
          items[i].addEventListener('click', function () {
            let currentBtn = document.querySelectorAll('.checked')
            currentBtn[0].className = currentBtn[0].className.replace('checked', '')
            this.className += " checked"
          })
        }
      },

      getsex(sex) {
        if (sex == 'both') {
          this.form.sex = "Both"
        }
        else if (sex == 'male') {
          this.form.sex = 'Male'
        }
        else {
          this.form.sex = 'Female'
        }
      },

      //get all patientLabo
      getPatienLabo() {
        axios.get('api/v1/laboratory/getPatientLabo')
          .then(res => {
            this.allItem = res.data
            this.labo = this.allItem.length
          })
      },
      messagebox() {
        var modal = document.getElementById("myModal");
        modal.style.display = "block";
        setTimeout(() => (modal.style.display = "none"), 2000);
      },
      formatdatetime(dateform) {
        try {
          return  moment(dateform).format('DD-MM-YYYY');
        } catch (error) {
          return dateform;
        }
      },
      //select detail
      select(labId) {
        this.$router.push({ name: 'Labolap', query: { id: labId } })
        this.pre = labId
        this.getTest()
        this.selectData()
      },
      selectData() {
        if (this.pre != '' && this.pre != 'undefined')
          axios.get('/api/v1/prescription/getprecriptoin/' + this.pre)
            .then(res => {
              this.form = res.data
              this.getDoctorname()
            })
      },
      getTest() {
        if (this.pre != '') {
          axios.get('/api/v1/laboratory/getLaboId/' + this.pre)
            .then(res => {
              this.alltests = res.data
              this.alltests.forEach(element => {
                this.count += parseFloat(element.test_value)
              });
            })
        }
      },
      async updateList(form) {
        await axios.post('api/v1/laboratory/updateList/' + form.id, form)
          .then(res => {
            this.message = "Save Successfully"
            this.messagebox()

            this.getTest()
          })
      },
      async submitBack(){
        if(this.pre != 'undefined'){
          await axios.get('api/v1/laboratory/SubmitBack/'+this.pre)
                    .then(res => {
                      this.message = "Submit successfully"
                      this.messagebox()
                      this.selectData()
                    })
                    this.getResultlabo()
                    this.getPatienLabo()
                    this.getTest()
        }


      },
      alertMessage(){
        this.message = "This is already submited"
        this.messagebox();
      },
      formatvalue(value){
        if(value != '' && value != null){
          if(value.match(/,/)){
              var splitText = value.split(',') 
              var newtext = ''
              splitText.forEach(element => {
                newtext += `${element}<br/>`
              });
              return newtext
          }
          else{
            return value
          }
        }else{
          return value
        }
        
      },
      checkValue(value){
        if(value != null && value != ''){
          if(value.slice(1,-1) === 'Positive' || value.slice(1,-1) === 'Negative' 
              || value.slice(1,-1) === 'Reaction Negative' || value.slice(1,-1) === 'Reaction Positive'
              || value.slice(1,-1) === 'Reaction Slight Negative' || value.slice(1,-1) === 'Reaction Slight Positive'
            )
          {
              return true
          }
          else{
              return false
          }
        }else{
          return true
        }
      },
      formatresult(result, normal_value){
        if(normal_value != null && normal_value != '' ){

            if(result != '' && result != null){

              if(normal_value.match(/,/)){
                  // var splitText = value.split(',') 
                  // var newtext = ''
                  // splitText.forEach(element => {
                  //   newtext += `${element}<br/>`
                  // });
                  return result
              }
              else  if(normal_value.match(/</)){
                    let myArray1 = (normal_value.slice(1,-1)).split('<')
                    if(myArray1.length == 2){
                      if(parseFloat(result) < parseFloat(myArray1[1])){
                          return `<span class="normal">${result}</span>`
                      }
                      else{
                          return `<span class="unnormal">${result}</span>`
                      }
                    }
                    if(myArray1.length == 3){
                        return result
                    }
              }
              else if(normal_value.match(/>/)){
                let myArray2 = (normal_value.slice(1,-1)).split('>')
                  if(myArray2.length == 2){
                    if(parseFloat(result) > parseFloat(myArray2[1])){
                        return `<span class="normal">${result}</span>`
                    }
                    else{
                        return `<span class="unnormal">${result}</span>`
                    }
                  }
                  if(myArray2.length == 3){
                      return result
                  }
              }
              else if(normal_value.match(/-/)){
                let myArray = (normal_value.slice(1,-1)).split('-')
                if(myArray.length == 2){
                    if(parseFloat(result) >= parseFloat(myArray[0]) && parseFloat(result) <= parseFloat(myArray[1])){
                        return `<span class="normal">${result}</span>`
                    }
                    else{
                        return `<span class="unnormal">${result}</span>`
                    }
                }
                else if(myArray.length == 3){
                }
              }
              else{
                let normal = normal_value.slice(1,-1)
                if(normal.toUpperCase() == result.toUpperCase()){
                  return `<span class="normal">${result}</span>`
                }else{
                  return `<span class="unnormal">${result}</span>`
                }
                
              }

            }else{
              return result
            }
        }else{
          return result
        }

      }
    },
  };
</script>
